Subject: bug#37806: 27.0.50; Need to "extend" face-remap.el

From: Ergus <[email-masked]>
Date: Sun, 20 Oct 2019 17:00:32 +0200

On Sat, Oct 19, 2019 at 08:33:33PM +0300, Eli Zaretskii wrote:
>> From: Stephen Berman <[email-masked]>
>> Date: Fri, 18 Oct 2019 11:14:09 +0200
>>
>> 0. emacs -Q
>> 1. C-x C-+ (i.e. M-x text-scale-adjust)
>> 2. M-x variable-pitch-mode or M-x buffer-face-mode
>> => Args out of range: [nil :family :foundry :swidth :height :weight :slant :underline :inverse :foreground ...], 19
>>
>> The error happens because the vector of face attributes defined in
>> face-remap.el is missing the recently added :extend attribute, so it is
>> too short.  This also breaks the MELPA package charmap.el (that's where
>> I hit the error).  The patch below fixes this, though perhaps now would
>> be a good time to do what the comment above the definition of the vector
>> says: "This variable should probably be defined in C code where the
>> actual definitions are available."  Or is this simple fix good enough?
>>
>> (The vector is also missing the :distant-foreground attribute, so the
>> patch adds that as well.  This absence happened to be innocuous because
>> the first element of the vector is nil, in order to make the attribute
>> indices match those of the enum lface_attribute_index defined in
>> dispextern.h, so the vector was long enough; but after the addition of
>> the :extend attribute, it wasn't anymore (only the indices of the vector
>> are used in face-remap.el).)
>>
>> In GNU Emacs 27.0.50 (build 17, x86_64-pc-linux-gnu, GTK+ Version 3.24.5, cairo version 1.16.0)
>>  of 2019-10-18 built on strobe-lfs84
>> Repository revision: 2d13a3f68d4724af52e47675bedf60709c7b5171
>> Repository branch: master
>> Windowing system distributor 'The X.Org Foundation', version 11.0.12003000
>> System Description: Linux From Scratch
>>
>>
>> diff --git a/lisp/face-remap.el b/lisp/face-remap.el
>> index 5cdecb92ee..8e565264fe 100644
>> --- a/lisp/face-remap.el
>> +++ b/lisp/face-remap.el
>> @@ -69,7 +69,7 @@ internal-lisp-face-attributes
>>    [nil
>>     :family :foundry :swidth :height :weight :slant :underline :inverse
>>     :foreground :background :stipple :overline :strike :box
>> -   :font :inherit :fontset :vector])
>> +   :font :inherit :fontset :distant :extend :vector])
>>
>>  (defun face-attrs-more-relative-p (attrs1 attrs2)
>>    "Return true if ATTRS1 contains a greater number of relative
>
>Thanks.
>
>Jimmy, could you please take a look?

Hi:

I just pushed a fix for this.

BTW: I don't know how to close a bug report. It is not in the CONTRIBUTE
file.